﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using EPiServer.ConnectForCampaign.Core.Configuration;
using EPiServer.ConnectForCampaign.Core.Implementation;
using EPiServer.ConnectForCampaign.Services;
using EPiServer.ConnectForCampaign.Services.Implementation;
using EPiServer.Framework;
using EPiServer.Framework.Initialization;
using EPiServer.ServiceLocation;
using EPiServer.Shell.ObjectEditing;

namespace AlloySample.Business.Initialization
{
    [InitializableModule]
    [ModuleDependency(typeof(EPiServer.ConnectForCampaign.Implementation.InitializationModule))]
    public class CustomCampaignConnectorInitialization : IConfigurableModule
    {
        public void ConfigureContainer(ServiceConfigurationContext context)
        {
            //context.Services.AddSingleton<IOptinProcessService, CustomOptinProcessServive>();
            //context.Services.AddTransient<IOptinProcessService, CustomOptinProcessServive>();

            //working
            context.StructureMap().Configure(c => c.For(typeof(OptinProcessService)).Use(typeof(CustomOptinProcessServive)));
            context.StructureMap().Configure(c => c.For(typeof(RecipientService)).Use(typeof(CustomRecipientService)));
        }

        public void Initialize(InitializationEngine context)
        {
        }

        public void Uninitialize(InitializationEngine context)
        {
        }
    }
}